.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include AddinTester.inc

.code
start:

	invoke GetModuleHandle,NULL
	mov hInstance,eax
    invoke InitCommonControls

	;Get path to addin and load it
	invoke CommandLine,offset AddinPath,sizeof AddinPath
	invoke lstrlen,offset AddinPath
	mov edx,offset AddinPath
	add edx,eax
	sub edx,4
	mov eax,[edx]
	.if eax!="lld."
		invoke MessageBox,0,offset szNotAnAddin,offset szWarning,MB_OK or MB_ICONWARNING
		jmp @F
	.endif
	
	invoke LoadLibrary,offset AddinPath
	mov hAddin,eax
	
	;pointer to project file
	invoke lstrcpy,offset ProjectRap,offset AddinPath
	mov edx,offset ProjectRap
	invoke lstrlen,edx
	add edx,eax
	mov byte ptr [edx - 2],"p"
	mov byte ptr [edx - 3],"a"
	mov byte ptr [edx - 4],"r"
	
	
	mov Data.fMaximized,FALSE
	mov Processes.lpGetWordFromPos,offset GetWordFromPos
	mov Data.lpProject,offset ProjectRap ;project.rap
	mov Data.lpIniFile,offset szRadasmIni ;radasm.ini
	
	;Get Options
	invoke GetProcAddress,hAddin,offset szInstallDll
	.if eax==0
		invoke GetLastError
		invoke FormatMessage,FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM or \ 
    			FORMAT_MESSAGE_IGNORE_INSERTS,NULL,eax,NULL,offset hAddin,0,NULL
    	invoke lstrcpy,offset ErrorMessages,hAddin
    	invoke lstrcat,offset ErrorMessages,offset szNotRadAsmAddin
    	invoke MessageBox,0,offset ErrorMessages,offset szWarning,MB_OK or MB_ICONWARNING
		jmp @F
	.endif
	
	invoke GetProcAddress,hAddin,offset szGetOptions
	.if eax!=0
		call eax
		invoke DialogBoxParam,hInstance,IDD_OPTION,NULL,addr OptionDlgProc,eax
	.endif

	invoke LoadLibrary,offset szRichEditDLL
	.if eax!=0
		mov hRichEdit,eax
		invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
		invoke FreeLibrary,hRichEdit
	.endif
@@:
	invoke ExitProcess,0

include Option.asm

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL buffer[512]:byte
	LOCAL AddinOpt:ADDINOPT
	
	push hWin
	pop hDlg
	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		mov IDM_ADDINBTN,10050
		;Handle of edit control
		invoke GetDlgItem,hWin,IDC_EDT1
		mov Handles.hEdit,eax
		invoke SetWindowLong,eax,GWL_WNDPROC,offset EditProc
		mov OldEditProc,eax
		
		;Handle of toolbar control and imagelist
		invoke GetDlgItem,hWin,IDC_TBR1
		mov Handles.hToolBar,eax
		push eax
		invoke ImageList_Create,16,16,ILC_MASK,0,5
		mov hImageList,eax
		pop eax
		invoke SendMessage,eax,TB_SETIMAGELIST,0,hImageList
		
		;Handle of menu
		invoke GetMenu,hWin
		mov Handles.hMenu,eax
		
		;Install addin
		invoke GetProcAddress,hAddin,offset szInstallDll
		push fOption
		push hWin
		call eax
		
		;Get tooltip
		invoke GetProcAddress,hAddin,offset szDllProc
		push 0
		push IDM_ADDINBTN
		push AIM_TBRTOOLTIP
		push hWin
		call eax
		mov pTooltip,eax
		
	.elseif eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==IDC_BTN1
			
			.elseif eax>=10050
				push eax
				invoke GetProcAddress,hAddin,offset szDllProc
				pop edx
				push 0
				push edx
				push AIM_COMMAND
				push hWin
				call eax
			.endif
		.endif
	.elseif eax==WM_NOTIFY
		mov edx,lParam
		mov eax,[edx].NMHDR.code
		mov edx,(NMHDR ptr [edx]).idFrom
		.if eax==TTN_NEEDTEXT && edx==IDM_ADDINBTN
			;Toolbar tooltip
			mov edx,lParam
			mov eax,pTooltip
			mov (TOOLTIPTEXT ptr [edx]).lpszText,eax
		.endif
	.elseif eax==TB_GETIMAGELIST
		invoke SetWindowLong,hWin,DWL_MSGRESULT,hImageList
	.elseif eax==AIM_GETMENUID
		inc IDM_ADDINBTN
		invoke SetWindowLong,hWin,DWL_MSGRESULT,IDM_ADDINBTN
	.elseif eax==AIM_GETHANDLES
		invoke SetWindowLong,hWin,DWL_MSGRESULT,offset Handles
	.elseif eax==AIM_GETPROCS
		invoke SetWindowLong,hWin,DWL_MSGRESULT,offset Processes
	.elseif eax==AIM_GETDATA
		invoke SetWindowLong,hWin,DWL_MSGRESULT,offset Data
	.elseif eax==WM_CLOSE
		invoke GetProcAddress,hAddin,offset szDllProc
		push 0
		push 0
		push AIM_CLOSE
		push hWin
		call eax
		invoke EndDialog,hWin,0
		invoke ImageList_Destroy,hImageList

	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret

DlgProc endp

CommandLine proc pArgbuffer:dword,cArgbuffer:dword
	
	invoke GetCommandLineW
	mov pCommandline,eax
	
	invoke CommandLineToArgvW,pCommandline,offset pNumArgs
	mov ebx,eax
	;First argument is path to application
	.if pNumArgs>1
		mov ecx,2
		;presume only one argument, e.i path to addin
		.while ecx<=pNumArgs
			push ecx
			push ecx
			;Commandline arguments
			pop eax
			sub eax,1
			mov edx,4
			mul edx
			invoke WideCharToMultiByte,CP_ACP,0,dword ptr [ebx + eax],-1,pArgbuffer,cArgbuffer,0,0
			pop ecx
			inc ecx
		.endw
	.endif
	
	ret

CommandLine endp

EditProc PROC hEdit:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	

	invoke CallWindowProc,OldEditProc,hEdit,uMsg,wParam,lParam
	ret
	
EditProc endp

GetWordFromPos proc hEdit:dword
	
	invoke SetFocus,hEdit
	invoke SendMessage,hEdit,EM_GETSELTEXT,0,offset SelectedWord
	 
	mov eax,offset SelectedWord
	ret

GetWordFromPos endp

end start
